// ChatDlg.h : header file
//

#if !defined(AFX_CHATDLG_H__9FCFD660_C9A1_4FD6_A14C_F694D13CBE7B__INCLUDED_)
#define AFX_CHATDLG_H__9FCFD660_C9A1_4FD6_A14C_F694D13CBE7B__INCLUDED_

#pragma warning(disable: 4786)

#import "..\..\..\common\VCProX.ocx"

using namespace VCProX;

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

const IID IID_IMediaGateEventSink = __uuidof(IvcproMediaGateEvents);

class CMediaGateEventSink : public CCmdTarget
{
public:
	HWND m_DialogHWND;
	CMediaGateEventSink();
	//virtual ~CMediaGateEventSink();

protected:
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CMediaGateEventSink)
	afx_msg void OnReceiveText(long ConnId, BSTR text);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()		
};

/////////////////////////////////////////////////////////////////////////////
// CChatDlg dialog

class CChatDlg : public CDialog
{
// Construction
public:
	CChatDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CChatDlg)
	enum { IDD = IDD_CHAT_DIALOG };
	CEdit	m_Port;
	CComboBox	m_Protocol;
	CComboBox	m_SamplingRate;
	CComboBox	m_Device;
	CEdit	m_EditInbox;
	CButton	m_Connect;
	BOOL	m_Ready;
	CString	m_Host;
	CString	m_Inbox;
	CString	m_Outbox;
	CString	m_Server;
	CString	m_Client;
	BOOL	m_Recording;
	BOOL	m_Playback;
	CString	m_SizeIn;
	CString	m_SizeOut;
	CString	m_PortStr;
	CString	m_FileName;
	BOOL	m_SaveToFile;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChatDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CChatDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButton1();
	afx_msg void OnCheck1();
	afx_msg void OnChangeEdit3();
	afx_msg void OnCheck2();
	afx_msg void OnCheck3();
	afx_msg void OnButton4();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton5();
	afx_msg void OnSaveToFile();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	UINT_PTR timer;
	//IvcproMediaGateXPtr m_Gate;
	HexComPtr<HEX_IIID(IvcproMediaGateX)> m_Gate;
	HexComPtr<HEX_IIID(IvcproWaveInDeviceX)> m_WaveIn;

	CMediaGateEventSink m_GateSink;
	LPUNKNOWN m_pUnkSink;
	DWORD m_dwCookie;

	void ConfigureGate();
	void VCInit();
	void VCUninit();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHATDLG_H__9FCFD660_C9A1_4FD6_A14C_F694D13CBE7B__INCLUDED_)
